"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class CancerExitQuestionnaire(ProtocolElement):
    """
    The cancer program exit questionnaire
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "caseLevelQuestions",
        "eventDate",
        "reporter",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_10 import reports as reports_6_4_0

        return {
            "caseLevelQuestions": reports_6_4_0.CancerCaseLevelQuestions,
            "germlineVariantLevelQuestions": reports_6_4_0.CancerGermlineVariantLevelQuestions,
            "otherActionableVariants": reports_6_4_0.AdditionalVariantsQuestions,
            "somaticVariantLevelQuestions": reports_6_4_0.CancerSomaticVariantLevelQuestions,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_10 import reports as reports_6_4_0

        return {
            "org.gel.models.report.avro.CancerCaseLevelQuestions": reports_6_4_0.CancerCaseLevelQuestions,
            "org.gel.models.report.avro.CancerGermlineVariantLevelQuestions": reports_6_4_0.CancerGermlineVariantLevelQuestions,
            "org.gel.models.report.avro.AdditionalVariantsQuestions": reports_6_4_0.AdditionalVariantsQuestions,
            "org.gel.models.report.avro.CancerSomaticVariantLevelQuestions": reports_6_4_0.CancerSomaticVariantLevelQuestions,
            "org.gel.models.report.avro.CancerExitQuestionnaire": reports_6_4_0.CancerExitQuestionnaire,
        }

    __slots__ = [
        "caseLevelQuestions",
        "eventDate",
        "reporter",
        "additionalComments",
        "germlineVariantLevelQuestions",
        "otherActionableVariants",
        "somaticVariantLevelQuestions",
    ]

    def __init__(
        self,
        caseLevelQuestions,
        eventDate,
        reporter,
        additionalComments=None,
        germlineVariantLevelQuestions=None,
        otherActionableVariants=None,
        somaticVariantLevelQuestions=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_6_4_0.CancerExitQuestionnaire model.

        :param caseLevelQuestions:
            The case level questions
        :type caseLevelQuestions: CancerCaseLevelQuestions
        :param eventDate:
            The date when the questionnaire was submitted
        :type eventDate: str
        :param reporter:
            The person that submitted the questionnaire
        :type reporter: str
        :param additionalComments:
            Please enter any additional comments you may have about the case here.
        :type additionalComments: None | str
        :param germlineVariantLevelQuestions:
            The questions for germline variants
        :type germlineVariantLevelQuestions: None | list[CancerGermlineVariantLevelQuestions]
        :param otherActionableVariants:
            Other actionable variants or entities. Please provide other
            (potentially) actionable entities: e.g domain 3 small
            variants or SV/CNV, mutational signatures, mutational
            burden
        :type otherActionableVariants: None | list[AdditionalVariantsQuestions]
        :param somaticVariantLevelQuestions:
            The questions for somatic variants
        :type somaticVariantLevelQuestions: None | list[CancerSomaticVariantLevelQuestions]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "6.4.0"
